/*
 * Defrole.java
 *
 * Created on February 18, 2002, 9:30 AM
 */

package org.semanticweb.dl;

import java.io.*;


/**
 * The defrole assertion.
 * @author  Michael Sintek
 * @version 
 */
public class Defrole extends Assertion {

  Symbol _roleSymbol;
  
  /** Creates new Defrole */
  public Defrole (Symbol symbol) {
    _roleSymbol = symbol; // check that it is a Resource ???
  }
  
  public Symbol getSymbol() {
    return _roleSymbol;
  }
  
  public void print(Syntax syntax, PrintWriter out) {
    if (syntax.showDefrole()) {
      if (syntax.XML()) {
        out.print("<DEFROLE NAME=\"");
        _roleSymbol.printSymbol(syntax, out);
        out.println("\"/>");
      } else {
        out.print("(defrole ");
        _roleSymbol.print(syntax, out);
        out.println(")");
      }
    }
  }
  
  public void toSHIQ(KB kb) {
    kb.add(new Defrole((Symbol)_roleSymbol.toSHIQ(kb, ROLE)));
  }

}
