/*
 * Disjoint.java
 *
 * Created on February 18, 2002, 11:40 AM
 */

package org.semanticweb.dl;

import java.util.*;
import java.io.*;


/**
 * Disjoint for handling daml:disjointWith.
 * @author  Michael Sintek
 * @version 
 */
public class Disjoint extends Assertion {

  Expression _expr1, _expr2;
  
  /** Creates new Disjoint */
  public Disjoint (Expression expr1, Expression expr2) {
    _expr1 = expr1;
    _expr2 = expr2;
  }
  
  public void print(Syntax syntax, PrintWriter out) {
    if (syntax.XML()) { // not supported!
      out.print ("<DISJOINT>");
      _expr1.print (syntax, out);
      _expr2.print (syntax, out);
      out.println ("</DISJOINT>");
    } else {
      out.print ("(disjoint ");
      _expr1.print (syntax, out);
      out.print (" ");
      _expr2.print (syntax, out);
      out.println (")");
    }
  }

  
  public void toSHIQ(KB kb) {
    // (disjoint c1 c2) -> implies(c1 (not c2))
    kb.add(new Implies(_expr1.toSHIQ(kb, CONCEPT), new Not(_expr2.toSHIQ(kb, CONCEPT))));
  }  
  
}
