/*
 * DotSyntax.java
 *
 * Created on February 28, 2002, 5:04 PM
 */

package org.semanticweb.dl;

import java.util.*;


/**
 *
 * @author  Michael Sintek
 * @version 
 */
public class DotSyntax extends Syntax {

  // dot syntax only works for RACER output at the moment,
  // i.e., only Defconcept, Implies, and Equal are supported.
  
  public DotSyntax(KB kb) {
    super(kb);
  }
  
  public boolean LISP() { return false; }
  public boolean DOT() { return true; }
  
  public boolean showDefconcept() { return true; }
  public boolean showDefrole() { return false; }
  // we need a lot more here ... !!!

  public String abbrevSplitter() { return ":"; }

  // we should cache this information after global analysis!!!
  List findEquals(Symbol concept) {
    // return list of equals if this is the representative
    // null if this is not the representative!
    ArrayList list = new ArrayList();
    for (Iterator iter = _kb._assertions.iterator(); iter.hasNext();) {
      Assertion assertion = ((Assertion)iter.next());
      if (assertion instanceof Equal) {
        Equal eq = (Equal)assertion;
        if (eq._expr1.equals(concept)) {
          Expression expr2 = eq._expr2;
          if (expr2 instanceof Symbol) { // we do not expect anything else
            list.add(expr2);
          }
        } else if (eq._expr2.equals(concept)) {
	  return null;
	}
      }
    }
    return list;
  }
    
}
