package org.semanticweb.glp;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;

/**
 * <p>Title: Triple</p>
 * <p>Description: RDF Query and Inference Language</p>
 * <p>Copyright: Copyright (c) 2001</p>
 * <p>Company: Stanford University</p>
 * @author Stefan Decker
 * @version 1.0
 */

public abstract class GLPBinaryOperator extends GLogicFormula {
  GLogicFormula l, r;

  public GLPBinaryOperator(GLogicFormula l, GLogicFormula r) {
    this.l = l;
    this.r = r;
  }


    public void renameVariables(HashMap h){
        l.renameVariables(h);
        r.renameVariables(h);
    }

    public final void freeBoundVariables(HashSet free, HashSet bound) {
        l.freeBoundVariables(free, bound);
        r.freeBoundVariables(free, bound);
    }

    public GLogicFormula getLeft(){
      return l;
    }

    public GLogicFormula getRight(){
      return r;
    }

    public String toString(GLogicFormula l, String Op, GLogicFormula r) {
        return "(".concat(l.toString()).concat(Op).concat(r.toString()).concat(")");
    }

}
