package org.semanticweb.glp;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;

/**
 *  <p>
 *
 *  Title: Triple</p> <p>
 *
 *  Description: RDF Query and Inference Language</p> <p>
 *
 *  Copyright: Copyright (c) 2001</p> <p>
 *
 *  Company: Stanford University</p>
 *
 *@author     Stefan Decker
 *@created    January 29, 2002
 *@version    1.0
 */

public abstract class GLPQuantifiedFormula extends GLogicFormula {
    ArrayList v;
    GLogicFormula f;


    /**
     *  Constructor for the GLPQuantifiedFormula object
     *
     *@param  v  Description of the Parameter
     *@param  f  Description of the Parameter
     */
    public GLPQuantifiedFormula(ArrayList v, GLogicFormula f) {
        this.v = v;
        this.f = f;
    }


    /**
     *  Description of the Method
     *
     *@param  free   Description of the Parameter
     *@param  bound  Description of the Parameter
     */
    public final void freeBoundVariables(HashSet free, HashSet bound) {
        for (int i = 0; i < v.size(); i++) {
            bound.add(v.get(i));
        }
        f.freeBoundVariables(free, bound);
    }


    /**
     *  Gets the variables attribute of the GLPQuantifiedFormula object
     *
     *@return    The variables value
     */
    public ArrayList getVariables() {
        return v;
    }


    /**
     *  Gets the left attribute of the GLPQuantifiedFormula object
     *
     *@return    The left value
     */
    public GLogicFormula getFormula() {
        return f;
    }

    public void renameVariables(HashMap h){
      f.renameVariables(h);
     }

    /**
     *  Description of the Method
     *
     *@param  q  Description of the Parameter
     *@param  v  Description of the Parameter
     *@param  f  Description of the Parameter
     *@return    Description of the Return Value
     */
    public final String toString(String q, ArrayList v, GLogicFormula f) {
        String result = q;
        for (Iterator i = v.iterator(); i.hasNext(); ) {
            result = result.concat(i.next().toString());
            if (i.hasNext()) {
                result = result.concat(",");
            }
            else {
                result = result.concat(" ");
            }
        }
        result = result.concat("(").concat(f.toString()).concat(")");
        return result;
    }

}
