package org.semanticweb.glp;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;

/**
 *  Title: Triple Description: RDF Query and Inference Language Copyright:
 *  Copyright (c) 2001 Company: Stanford University
 *
 *@author     Stefan Decker
 *@created    January 17, 2002
 *@version    1.0
 */

public class GLPRule extends GLPClause {
    ArrayList v;
    GLogicFormula h;
    GLogicFormula b;


    /**
     *  Constructor for the GLPRule object
     *
     *@param  v  Description of the Parameter
     *@param  h  Description of the Parameter
     *@param  b  Description of the Parameter
     */
    public GLPRule(ArrayList v, GLogicFormula h, GLogicFormula b) {
        this.v = v;
        this.h = h;
        this.b = b;
    }


     public  void renameVariables(HashMap map){
      h.renameVariables(map);
      b.renameVariables(map);
     }


    public GLogicFormula getHead(){
      return h;
    }

    public GLogicFormula getBody(){
      return b;
    }

    public ArrayList getVariables(){
      return v;
    }

    /**
     *  Constructor for the GLPRule object
     *
     *@param  h  Description of the Parameter
     *@param  b  Description of the Parameter
     */
    public GLPRule(GLogicFormula h, GLogicFormula b) {
        this.v = null;
        this.h = h;
        this.b = b;
    }




    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        String result = "";
        int k;
        if ((v != null) && !v.isEmpty()) {
            result = "FORALL ";
            for (Iterator i = v.iterator(); i.hasNext(); ) {
                result = result + i.next().toString();
                if (i.hasNext()) {
                    result = result.concat(",");
                }
                else {
                    result = result.concat(" ");
                }
            }
        }
        if (h != null) {
            result = result.concat(h.toString());
        }
        if (b != null) {
            result = result.concat(" <- ").concat(b.toString());
        }
        result = result.concat(".");
        return result;
    }
}
