package org.semanticweb.lp;

import java.util.ArrayList;
import java.util.Iterator;
import org.semanticweb.utilities.SyntaxHelper;


/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class FunctorTerm extends Term {
    Term[] args;
    String functor;


    /**
     *  Constructor for the FunctorTerm object
     *
     *@param  functor  Description of the Parameter
     *@param  args     Description of the Parameter
     */
    public FunctorTerm(String functor, ArrayList args) {
        // this.args = (Term[]) args.toArray(); // does not work! [MS]
        // so we have to copy the ArrayList :-(
        this.args = new Term[args.size()];
        int i = 0;
        for (Iterator iter = args.iterator(); iter.hasNext();) {
          this.args[i] = (Term)iter.next();
          i++;
        }
        this.functor = functor;
    }

    public FunctorTerm(String functor, Term[] args) {
        this.args = args;
        this.functor = functor;
    }


    /**
     *  Gets the args attribute of the FunctorTerm object
     *
     *@return    The args value
     */
    public Term[] getArgs() {
        return args;
    }


    /**
     *  Gets the arity attribute of the FunctorTerm object
     *
     *@return    The arity value
     */
    public int getArity() {
        return args.length;
    }


    /**
     *  Gets the functor attribute of the FunctorTerm object
     *
     *@return    The functor value
     */
    public String getFunctor() {
        return functor;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        String out = SyntaxHelper.symbol(functor, true);
        if ((args != null) && (args.length > 0)) {
            out = out.concat("(");
            for (int i = 0; i< args.length; i++) {
                out = out.concat(args[i].toString());
                if (i < args.length - 1) {
                    out = out.concat(",");
                }
            }
            out = out.concat(")");
        }
        return out;
    }
}
