package org.semanticweb.lp;

import java.util.ArrayList;
import java.util.Iterator;
import org.semanticweb.utilities.SyntaxHelper;


/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class Literal {
    String predicateSymbol;
    Term[] args;
    boolean polarity;


    /**
     *  Constructor for the Literal object
     *
     *@param  polarity         Description of the Parameter
     *@param  predicateSymbol  Description of the Parameter
     *@param  args             Description of the Parameter
     */
    public Literal(boolean polarity, String predicateSymbol, ArrayList args) {
        this.predicateSymbol = predicateSymbol;
        this.args = new Term[args.size()];
        this.args = (Term[]) args.toArray(this.args);
        this.polarity = polarity;
    }

    public Literal(boolean polarity, String predicateSymbol, Term[] args) {
        this.predicateSymbol = predicateSymbol;
        this.args = args;
        this.polarity = polarity;
    }


    /**
     *  Constructor for the Literal object
     *
     *@param  predicateSymbol  Description of the Parameter
     *@param  args             Description of the Parameter
     */
    public Literal(String predicateSymbol, ArrayList args) {
        this(true, predicateSymbol, args);
    }


    public Literal(String predicateSymbol, Term[] args) {
        this(true, predicateSymbol, args);
    }


    /**
     *  Gets the atom attribute of the Literal object
     *
     *@return    The atom value
     */
    public boolean isAtom() {
        return polarity;
    }


    /**
     *  Gets the polarity attribute of the Literal object
     *
     *@return    The polarity value
     */
    public boolean getPolarity() {
        return polarity;
    }


    /**
     *  Gets the args attribute of the Literal object
     *
     *@return    The args value
     */
    public Term[] getArgs() {
        return args;
    }


    /**
     *  Gets the predicateSymbol attribute of the Literal object
     *
     *@return    The predicateSymbol value
     */
    public String getPredicateSymbol() {
        return predicateSymbol;
    }


    /**
     *  Gets the arity attribute of the Literal object
     *
     *@return    The arity value
     */
    public int getArity() {
        return args.length;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */

    public String toString() {
        String out = "";
        if (!polarity) {
            out = out.concat("not ");
        }
        out = out.concat(SyntaxHelper.symbol(predicateSymbol, true));
        if ((args != null) && (args.length > 0)) {
            out = out.concat("(");
            for (int i=0;i < args.length;i++){
                out = out.concat(args[i].toString());
                if (i < args.length-1)
                    out = out.concat(",");
            }
            out = out.concat(")");
        }
        return out;
    }
    
}
