package org.semanticweb.triple.inference;

/**
 *  Copyright  Juergen Angele and Stefan Decker, Institut AIFB, University of
 *  Karlsruhe. All Rights Reserved.
 *
 *@author     Administrator
 *@created    January 17, 2002
 */

/**
 *  Method to compare two things.
 *
 *@author     Juergen Angele
 *@author     Stefan Decker
 *@created    January 17, 2002
 *@version    TRIPLE 1.0
 */

public interface Comparison {
    /**
     *  Defines the method to compare elements. Returns
     *  <ul>
     *    <li> -1 if t1 < t2
     *    <li> 0 if t1 == t2
     *    <li> 1 if t1 > t2
     *    <li> -2 if the relation of t1 and t2 is not known
     *  </ul>
     *  This is an abstract method and has to be instantiated by the subclass
     *
     *@param  t1  Description of the Parameter
     *@param  t2  Description of the Parameter
     *@return     Description of the Return Value
     */

    public abstract int Compare(Object t1, Object t2);

}
