package org.semanticweb.triple.inference;

/*
 *  Copyright  Juergen Angele and Stefan Decker,
 *  Institut AIFB, University of Karlsruhe.
 *  All Rights Reserved.
 *
 */
import java.io.*;
import java.util.*;
import java.net.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class GroundAtom {
    int symbol;
    // symbol is nowhere referenced in the source...
    /**
     *  Description of the Field
     */
    public Term terms[];

    static long actmark = 0;
    // for cycle detection
    /**
     *  Description of the Field
     */
    public long cyclemark = 0;
    /**
     *  Description of the Field
     */
    public int mark = 0;
    private static boolean debug = false;
    /**
     *  Description of the Field
     */
    public static long no = 0;
    // total number of ground atoms
    /**
     *  Description of the Field
     */
    public GroundAtom next2 = null;
    // list of tupels
    /**
     *  Description of the Field
     */
    public long lasttouched = 0;
    // time stamp of the last touch
    /**
     *  Description of the Field
     */
    public boolean deleted = false;

    // terms of the atom
    /**
     *  Description of the Field
     */
    public ATMS supported = null;
    // link to dependent atoms
    int no_supports = 0;
    // number of links to this atoms
    int max_supports = 0;
    boolean and = false;
    // for the ATMS

    /**
     *  Description of the Field
     */
    public long num = 0;
    static LinkedList atmslist = null;

    /**
     *  Description of the Field
     */
    public boolean cycle = false;
    // is the atom inside a cycle?

    /**
     *  Description of the Field
     */
    public boolean sure = true;


    // atom may not become unknown

    /**
     *  The constructur defines a new GroundAtoms
     *
     *@param  t  the terms of the ground atom
     */

    public GroundAtom(Term t[]) {
        no++;
        num = no;
        int anz = 0;
        int i;
        if (t != null) {
            anz = t.length;
        }
        terms = new Term[anz];
        for (i = 0; i < anz; i++) {
            terms[i] = t[i];
        }
    }


    /**
     *  The constructur defines a new GroundAtoms without initalizing the terms
     *
     *@param  length  is the number of terms
     */

    public GroundAtom(int length) {
        no++;
        num = no;
        terms = new Term[length];
    }


    /**
     *  Description of the Method
     *
     *@param  pos     Description of the Parameter
     *@param  source  Description of the Parameter
     */
    private void changeSupport(boolean pos, GroundAtom source) {
        if (debug) {
            System.out.print("-> changeSupport: ");
            this.print(System.out);
            System.out.println();
        }
        GroundAtom a;
        ATMS at;
        actmark++;
        atmslist = new LinkedList();
        changeSupport1(pos);
        while (atmslist.size() > 0) {
            a = (GroundAtom) atmslist.removeFirst();
            a.checkSupport();
        }
        atmslist = null;
    }


    /**
     *  Description of the Method
     *
     *@param  pos  Description of the Parameter
     */
    private void changeSupport1(boolean pos) {
        if (debug) {
            System.out.print("-> changeSupport1(");
            System.out.print(pos);
            System.out.print(",");
            this.print(System.out);
            System.out.print("):");
            System.out.println(this.no_supports);
        }

        ATMS at;
        if (pos) {
            no_supports++;
            if (this.deleted) {
                if ((and && (no_supports >= max_supports)) || (!and && (no_supports > 0)) || cycle) {
                    if (!and && no_supports <= 0) {
                        atmslist.addLast(this);
                        if (debug) {
                            System.out.print("      Store:    ");
                            this.print();
                            System.out.println();
                        }
                    }
                    this.deleted = false;
                    if (debug) {
                        System.out.print("      Undelete: ");
                        this.print();
                        System.out.println();
                    }
                    if (this.cyclemark != actmark) {
                        this.cyclemark = actmark;
                        for (at = this.supported; at != null; at = at.next) {
                            at.atom.changeSupport1(at.pos);
                        }
                    }
                }
            }
        }
        else {
            no_supports--;
            if (!this.deleted) {
                if (and || (no_supports <= 0) || cycle) {
                    if (!and && no_supports > 0) {
                        atmslist.addLast(this);
                        if (debug) {
                            System.out.print("      Store:  ");
                            this.print();
                            System.out.println();
                        }
                    }
                    this.deleted = true;
                    if (debug) {
                        System.out.print("      Delete: ");
                        this.print();
                        System.out.println();
                    }
                    if (this.cyclemark != actmark) {
                        this.cyclemark = actmark;
                        for (at = this.supported; at != null; at = at.next) {
                            at.atom.changeSupport1(!at.pos);
                        }
                    }
                }
            }
        }
    }



    /**
     *  Description of the Method
     *
     *@param  pos  Description of the Parameter
     */
    private void changeSupport2(boolean pos) {
        if (debug) {
            System.out.print("-> changeSupport2(");
            System.out.print(pos);
            System.out.print(",");
            this.print(System.out);
            System.out.print("):");
            System.out.println(this.no_supports);
        }
        ATMS at;
        if (pos) {
            no_supports++;
            if (this.deleted) {
                if ((and && (no_supports >= max_supports)) || (!and && (no_supports > 0))) {
                    this.deleted = false;
                    if (debug) {
                        System.out.print("      Undelete: ");
                        this.print();
                        System.out.println();
                    }
                    for (at = this.supported; at != null; at = at.next) {
                        at.atom.changeSupport2(at.pos);
                    }
                }
            }
        }
        else {
            no_supports--;
            if (!this.deleted) {
                if (and || (!and && (no_supports <= 0))) {
                    this.deleted = true;
                    if (debug) {
                        System.out.print("      Delete: ");
                        this.print();
                        System.out.println();
                    }
                    for (at = this.supported; at != null; at = at.next) {
                        at.atom.changeSupport2(!at.pos);
                    }
                }
            }
        }
    }


    /**
     *  Description of the Method
     */
    private void checkSupport() {
        if (debug) {
            System.out.print("-> checkSupport: ");
            this.print(System.out);
            System.out.print(":");
            System.out.println(this.no_supports);
        }
        ATMS at;
        if (this.deleted) {
            if ((and && (no_supports >= max_supports)) || (!and && (no_supports > 0))) {
                this.deleted = false;
                if (debug) {
                    System.out.print("      Undelete: ");
                    this.print();
                    System.out.println();
                }
                for (at = this.supported; at != null; at = at.next) {
                    at.atom.changeSupport2(at.pos);
                }
            }
        }
        else {
            if (and || (!and && (no_supports <= 0))) {
                this.deleted = true;
                if (debug) {
                    System.out.print("      Delete: ");
                    this.print();
                    System.out.println();
                }
                for (at = this.supported; at != null; at = at.next) {
                    at.atom.changeSupport2(!at.pos);
                }
            }
        }
    }


    /**
     *  Description of the Method
     *
     *@param  i1  Description of the Parameter
     *@param  t2  Description of the Parameter
     *@param  i2  Description of the Parameter
     *@return     Description of the Return Value
     */
    public int Compare(int i1, GroundAtom t2, int i2) {
        return terms[i1].Compare((t2).terms[i2]);
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     *@return    Description of the Return Value
     */
    public int CompareAtoms(GroundAtom t) {
        // vergleicht zwei Tupel miteinander
        int i;
        int res = 0;
        for (i = 0; (i < terms.length) && (res == 0); i++) {
            res = terms[i].Compare((t).terms[i]);
        }
        return res;
    }


    /**
     *  Deletes edges in ATMS from this atom to all marked atoms
     */

    public void CutATMS() {
        ATMS h;
        ATMS hold = null;
        for (h = this.supported; h != null; h = h.next) {
            // falls angehngtes Atom markiert ausketten aus Liste
            if (h.atom.mark > 0) {
                if (hold == null) {
                    this.supported = h.next;
                }
                else {
                    hold.next = h.next;
                }
            }
            hold = h;
        }
    }


    /**
     *  Description of the Method
     *
     *@param  a  Description of the Parameter
     */
    public void Disports(GroundAtom a) {
        ATMS h;
        if (!this.deleted) {
            for (h = this.supported; h != null; h = h.next) {
                if (!h.pos) {
                    (h.atom).changeSupport(false, a);
                }
            }
        }
    }


    /**
     *  Description of the Method
     */
    public void Enable() {
        ATMS h;
        for (h = this.supported; h != null; h = h.next) {
            if (h.pos) {
                (h.atom).changeSupport(true, this);
            }
        }
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String internalize() {
        int i;
        String s = String.valueOf(terms.length);
        for (i = 0; i < terms.length; i++) {
            if (terms[i] != null) {
                s = s + terms[i].internalize();
            }
        }
        return s;
    }


    /**
     *  Description of the Method
     *
     *@param  p  Description of the Parameter
     */
    public void internalize(PrintStream p) {
        int i;
        p.print("l" + String.valueOf(terms.length));
        for (i = 0; i < terms.length; i++) {
            if (terms[i] != null) {
                terms[i].internalize(p);
            }
        }
    }


    /**
     *  Description of the Method
     *
     *@param  p    Description of the Parameter
     *@param  sym  Description of the Parameter
     */
    public void internalize(PrintStream p, int sym) {
        int i;
        p.print("p" + String.valueOf(sym) + "l" + String.valueOf(terms.length));
        for (i = 0; i < terms.length; i++) {
            if (terms[i] != null) {
                terms[i].internalize(p);
            }
        }
    }


    /**
     *  Description of the Method
     *
     *@param  a  Description of the Parameter
     */
    public void negDependency(GroundAtom a) {
        ATMS h;
        for (h = this.supported; (h != null) && (h.atom != a); h = h.next) {
            ;
        }
        if (h == null) {
            h = new ATMS(a);
            h.pos = false;
            h.next = this.supported;
            this.supported = h;
        }
    }


    /**
     *  Description of the Method
     */
    public void Retract() {
        ATMS h;
        for (h = this.supported; h != null; h = h.next) {
            if (h.pos) {
                (h.atom).changeSupport(false, this);
            }
        }
    }


    /**
     *  Atom a is supported by this atom
     *
     *@param  a  Description of the Parameter
     */
    public void Supports(GroundAtom a) {
        ATMS h;
        for (h = this.supported; (h != null) && (h.atom != a); h = h.next) {
            ;
        }
        if (h == null) {
            if (debug) {
                this.print(System.out);
                System.out.print(" -> ");
                a.print(System.out);
                System.out.println();
            }
            h = new ATMS(a);
            a.max_supports += 1;
            h.next = this.supported;
            this.supported = h;
            if (this.sure == false) {
                a.sure = false;
            }
            a.changeSupport(true, this);
            // if (a.max_supports < a.no_supports) a.max_supports = a.no_supports;
            if (deleted) {
                a.changeSupport(false, this);
            }
        }
    }


    /**
     *  Description of the Method
     */
    public void print() {
        int i;
        for (i = 0; i < terms.length; i++) {
            if (terms[i] != null) {
                terms[i].print(System.out);
            }
            else {
                System.out.print("null");
            }
            if (i < terms.length - 1) {
                System.out.print(",");
            }
        }
        System.out.print(" : ");
        System.out.print(num);
        if (deleted) {
            System.out.print(":del");
        }
    }


    /**
     *  Description of the Method
     *
     *@param  p  Description of the Parameter
     */
    public void print(PrintStream p) {
        int i;
        for (i = 0; i < terms.length; i++) {
            if (terms[i] != null) {
                terms[i].print(p);
            }
            else {
                p.print("null");
            }
            if (i < terms.length - 1) {
                p.print(",");
            }
        }
        p.print(" : ");
        p.print(num);
        if (deleted) {
            p.print(":del");
        }
    }


    /**
     *  Description of the Method
     *
     *@param  p   Description of the Parameter
     *@param  pr  Description of the Parameter
     *@param  f   Description of the Parameter
     *@param  s   Description of the Parameter
     */
    public void print(PrintStream p, String pr[], String f[], String s[]) {
        int i;
        for (i = 0; i < terms.length; i++) {
            p.print("\"");
            if (terms[i] != null) {
                terms[i].print(p, pr, f, s);
            }
            else {
                p.print("null");
            }
            p.print("\"");
            if (i < terms.length - 1) {
                p.print(",");
            }
        }
    }


    /**
     *  Description of the Method
     *
     *@param  p    Description of the Parameter
     *@param  sym  Description of the Parameter
     */
    public void print(PrintStream p, int sym) {
        int i;
        p.print("p");
        p.print(sym);
        p.print("(");
        for (i = 0; i < terms.length; i++) {
            if (terms[i] != null) {
                terms[i].print(p);
            }
            else {
                p.print("null");
            }
            if (i < terms.length - 1) {
                p.print(",");
            }
        }
        p.print(")");
    }


    /**
     *  Description of the Method
     *
     *@param  p    Description of the Parameter
     *@param  sym  Description of the Parameter
     *@param  pr   Description of the Parameter
     *@param  f    Description of the Parameter
     *@param  s    Description of the Parameter
     */
    public void print(PrintStream p, int sym, String pr[], String f[], String s[]) {
        int i;
        p.print(pr[sym]);
        p.print("(");
        for (i = 0; i < terms.length; i++) {
            if (terms[i] != null) {
                terms[i].print(p, pr, f, s);
            }
            else {
                p.print("null");
            }
            if (i < terms.length - 1) {
                p.print(",");
            }
        }
        p.print(")");
    }


    /**
     *  Description of the Method
     */
    private void throwException() {
        try {
            throw new Exception();
        } catch (Exception e) {
            System.err.println("Exception: " + e);
            e.printStackTrace();
            System.exit(0);
        }
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        int i;
        String s = "";
        for (i = 0; i < terms.length; i++) {
            if (terms[i] != null) {
                s += terms[i].toString();
            }
            else {
                s += "null";
            }
            if (i < terms.length - 1) {
                s += ",";
            }
        }
        s += " : ";
        s += Long.toString(num);
        if (deleted) {
            s += ":del";
        }
        return s;
    }


    /**
     *  Description of the Method
     *
     *@param  p   Description of the Parameter
     *@param  pr  Description of the Parameter
     *@param  f   Description of the Parameter
     *@param  st  Description of the Parameter
     *@return     Description of the Return Value
     */
    public String toString(String p, String pr[], String f[], String st[]) {
        int i;
        String s = p + "(";
        for (i = 0; i < terms.length; i++) {
            if (terms[i] != null) {
                s = s.concat(terms[i].toString(pr, f, st));
            }
            if (i < terms.length - 1) {
                s = s.concat(",");
            }
        }
        s = s.concat(")");
        return s;
    }
}
