package org.semanticweb.triple.inference;

/*
 *  Name: HashSymbolTable
 *  Version: 1.0
 *  Purpose: stores symbols
 *  History:
 */
import java.io.*;
import java.util.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class HashSymbolTable {
    Hashtable symbols = null;
    int counter;
    Vector rollbackStore;
    boolean rollback = false;
    boolean insertMode = true;


    /**
     *  Constructor for the HashSymbolTable object
     */
    public HashSymbolTable() {
        // Constructor

        symbols = new Hashtable();
        int counter = 0;
        rollback = false;
        insertMode = true;
    }


    /**
     *  Gets the content attribute of the HashSymbolTable object
     *
     *@param  i  Description of the Parameter
     *@return    The content value
     */
    public SymbolWrapper getContent(int i) {
        SymbolWrapper sw = (SymbolWrapper) symbols.get(new Integer(i));
        return sw;
    }


    /**
     *  Gets the insertMode attribute of the HashSymbolTable object
     *
     *@return    The insertMode value
     */
    public boolean getInsertMode() {
        return insertMode;
    }


    /**
     *  Gets the size attribute of the HashSymbolTable object
     *
     *@return    The size value
     */
    public int getSize() {
        return counter;
    }


    /**
     *  Description of the Method
     */
    public void rollback() {
        for (java.util.Enumeration e = rollbackStore.elements(); e.hasMoreElements(); ) {
            Object i = e.nextElement();
            SymbolWrapper sw = (SymbolWrapper) symbols.get(i);
            if (sw.decreaseReference()) {
                symbols.remove(i);
                symbols.remove(sw);
            }

        }
        rollbackStore = null;
        rollback = false;
    }


    /**
     *  Description of the Method
     *
     *@param  sw  Description of the Parameter
     *@return     Description of the Return Value
     */
    public int search(SymbolWrapper sw) {
        Integer i = (Integer) symbols.get(sw);
        if (i == null) {
            return -1;
        }
        return i.intValue();
    }


    /**
     *  Description of the Method
     *
     *@param  sw  Description of the Parameter
     *@return     Description of the Return Value
     */
    public int searchAndInsert(SymbolWrapper sw) {
        Integer i = (Integer) symbols.get(sw);
        if (i == null) {
            i = new Integer(counter++);
            if (insertMode) {
                symbols.put(i, sw);
                symbols.put(sw, i);
                if (rollback) {
                    rollbackStore.add(i);
                }
            }
        }
        else {
            sw = (SymbolWrapper) symbols.get(i);
            if (insertMode) {
                sw.increaseReference();
            }
            else {
                if (sw.decreaseReference()) {
                    symbols.remove(i);
                    symbols.remove(sw);
                }
            }

        }
        return i.intValue();
    }


    /**
     *  Sets the insertMode attribute of the HashSymbolTable object
     *
     *@param  insertMode  The new insertMode value
     */
    public void setInsertMode(boolean insertMode) {
        this.insertMode = insertMode;
    }


    /**
     *  Sets the rollback attribute of the HashSymbolTable object
     */
    public void setRollback() {
        rollbackStore = new Vector();
        rollback = true;
    }
}
