package org.semanticweb.triple.inference;

/*
 *  Name: IndexInterface.java
 *  Version: 1.0
 *  Purpose: Interface for an index datastructure
 *  History:
 */
import java.util.NoSuchElementException;

/**
 *  Description of the Interface
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public interface IndexInterface {

    /**
     *  Delete the element identical (not only equal in the sense of Compare) to
     *  ele To delete an arbitrary element this element has to be searched by
     *  Search before
     *
     *@param  ele  Description of the Parameter
     */
    public void Delete(Object ele);


    /**
     *  Returns an enumeration for the elements
     *
     *@return    Description of the Return Value
     */
    public IndexEnumeration elements();


    /**
     *  Insert a new element. Returns ele if ele has been inserted. Returns the
     *  element equal to ele, if ele has not been inserted
     *
     *@param  ele  Description of the Parameter
     *@return      Description of the Return Value
     */
    public Object Insert(Object ele);


    /**
     *  Returns the number of elements stored in the index
     *
     *@return    Description of the Return Value
     */
    public int NoElements();


    /**
     *  Searches for an element equal (in the sense of Compare) to ele
     *
     *@param  ele  Description of the Parameter
     *@return      Description of the Return Value
     */
    public Object Search(Object ele);
}
