package org.semanticweb.triple.inference;

import java.io.*;
import java.util.*;
import java.util.Enumeration;
import java.util.NoSuchElementException;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
class Keller {
    private int pg;
    private int size;
    private AVLnode k[];


    /**
     *  Constructor for the Keller object
     *
     *@param  max  Description of the Parameter
     */
    protected Keller(int max) {
        k = new AVLnode[max + 1];
        size = max;
        pg = -1;
    }


    /**
     *  Description of the Method
     */
    protected void Clear() {
        pg = -1;
    }


    /**
     *  Description of the Method
     *
     *@param  kel  Description of the Parameter
     */
    protected void Copy(Keller kel) {
        int i;
        for (i = 0; i <= kel.pg; i++) {
            k[i] = kel.k[i];
        }
        pg = kel.pg;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    protected boolean Empty() {
        return pg < 0;
    }


    /**
     *  Description of the Method
     */
    protected void Pop() {
        if (pg >= 0) {
            pg--;
        }
    }


    /**
     *  Description of the Method
     */
    protected void print() {
        for (int i = 0; i <= pg; i++) {
            k[i].print();
        }
        System.out.println();
    }


    /**
     *  Description of the Method
     *
     *@param  a  Description of the Parameter
     */
    protected void Push(AVLnode a) {
        k[++pg] = a;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    protected AVLnode Top() {
        if (pg >= 0) {
            return k[pg];
        }
        else {
            return null;
        }
    }
}
