package org.semanticweb.triple.inference;

/*
 *  Name: Atoms.java
 *  Version: 2.0
 *  Purpose: a container for atoms with appropriate access data structures
 *  (AVL trees)
 *  History:
 */
import java.io.*;
import java.util.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
abstract class SearchOperation {
    int debuglevel = 0;
    long timestamp;
    Comparison comp;
    Atoms R1, D;
    Atom T;
    GroundAtom a;


    /**
     *  Constructor for the org.semanticweb object
     *
     *@param  R     Description of the Parameter
     *@param  T     Description of the Parameter
     *@param  D     Description of the Parameter
     *@param  Time  Description of the Parameter
     */
    public SearchOperation(Atoms R, Atom T, Atoms D, long Time) {
        this.R1 = R;
        this.D = D;
        this.T = T;
        this.timestamp = Time;
        comp = new CompareAtoms(R.matchindex, R.matchindex);
        R.tuples2 = null;
        D.tuples2 = null;
    }


    /**
     *  Description of the Method
     *
     *@param  b1  Description of the Parameter
     *@param  b2  Description of the Parameter
     */
    public abstract void op(GroundAtom b1, GroundAtom b2);


    /**
     *  Description of the Method
     */
    public void Operate() {
        IndexEnumeration enm;
        if (debuglevel > 1) {
            System.out.println("Atom:");
            System.out.println(T.toString());
            System.out.println("Source:");
            R1.print(System.out);
            System.out.println();
        }
        enm = (IndexEnumeration) R1.indices.avl.elements();
        enm.setComparisonMethod(comp);
        enm.positionToElement(T);
        while (enm.hasMoreElements()) {
            a = (GroundAtom) enm.nextElement();
            op(a, T);
        }
        if (debuglevel > 1) {
            System.out.println("Destinitation:");
            D.print(System.out);
        }

    }
}
