package org.semanticweb.triple.inference;

/*
 *  Name: AVLTree.java
 *  Version: 1.1
 *  Purpose: AVL tree used as access data structures at different places
 *  History:
 */
import java.io.*;
import java.util.*;
import java.util.Enumeration;
import java.util.NoSuchElementException;
/*
 *  class watch {
 *  long start,ende;
 *  long timeused = 0;
 *  public void press() {
 *  start = (new Date()).getTime();
 *  }
 *  public void release() {
 *  ende = (new Date()).getTime();
 *  timeused += ende - start;
 *  }
 *  public void print() {
 *  System.out.println(timeused);
 *  }
 *  public void reset() {
 *  timeused =0;
 *  }
 *  }
 */
/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
class avlenum {
    private AVLTree avl;
    private Keller current;
    static int kellermax = 40;
    private AVLnodeDup cur = null;
    private Comparison compare;
    boolean firstaccess = true;


    /**
     *  Constructor
     *
     *@param  a  Description of the Parameter
     */
    public avlenum(AVLTree a) {
        avl = a;
        compare = avl.comp;
        current = new Keller(kellermax);
    }


    /**
     *  Are there more elements available?
     *
     *@return    Description of the Return Value
     */
    public boolean hasMoreElements() {
        if (firstaccess && avl.tree != null) {
            return true;
        }
        if (!current.Empty() || cur != null) {
            return true;
        }
        return false;
    }


    /**
     *  Give the next element. Throws NoSuchElementException if no further
     *  element is available
     *
     *@return                             Description of the Return Value
     *@exception  NoSuchElementException  Description of the Exception
     */
    public AVLnode nextElement() throws NoSuchElementException {
        AVLnode a;
        AVLnode b;
        if (firstaccess) {
            firstaccess = false;
            b = avl.tree;
            while (b != null) {
                current.Push(b);
                b = b.links;
            }
        }
        if (cur != null) {
            a = cur;
            cur = cur.mitte;
            return a;
        }
        else if (!current.Empty()) {
            a = current.Top();
            current.Pop();
            if (a.rechts != null) {
                current.Push(a.rechts);
                b = a.rechts.links;
                while (b != null) {
                    current.Push(b);
                    b = b.links;
                }
            }
            if (a instanceof AVLnodeDup) {
                cur = ((AVLnodeDup) a).mitte;
            }
            //System.out.println(((GroundAtom)a.data).toString());
            return a;
        }
        return null;
    }


    /**
     *  Description of the Method
     */
    public void print() {
        System.out.println("Stack:");
        current.print();
    }
}
