package org.semanticweb.triple.inference.builtins;
import java.lang.Math;
import org.semanticweb.triple.inference.Atom;
import org.semanticweb.triple.inference.StringTerm;
import org.semanticweb.triple.inference.BuiltinFunc;
import org.semanticweb.triple.inference.SimpleEvaluator;
import org.semanticweb.triple.inference.SimpleEvaluatorConfig;
import org.semanticweb.triple.inference.ConstTerm;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class Concat extends BuiltinFunc {
    /**
     *  Constructor for the Concat object
     */
    public Concat() {
        super();
    }


    /**
     *  Constructor for the Concat object
     *
     *@param  eval  Description of the Parameter
     */
    public Concat(SimpleEvaluator eval) {
        super(eval);
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     */
    public void eval(Atom t) {
        int i;
        int len;
        String args[];
        String result = "";
        String result1 = "";
        boolean stringterm = false;
        args = new String[3];
//System.out.println("-> Concat");
        if (evaluable(t)) {
            for (i = 0; i < 3; i++) {
                if (t.terms[i].ground) {
                    if (t.terms[i] instanceof StringTerm) {
                        args[i] = ((StringTerm) t.terms[i]).s;
                        stringterm = true;
                    }
                    else {
                        args[i] = eval.getString(((ConstTerm) t.terms[i]).symbol);
                    }
                }
            }
            if (t.terms[0].ground && t.terms[1].ground && t.terms[2].ground) {
                if (0 == args[0].compareTo(args[1] + args[2])) {
                    insert(t);
                }
            }
            else if (t.terms[0].ground && t.terms[1].ground) {
                result = args[0] + args[1];
                subs(t, result, 2, stringterm);
                insert(t);
            }
            else if (t.terms[0].ground && t.terms[2].ground) {
                if (args[2].startsWith(args[0])) {
                    result = args[2].substring(args[0].length());
                    subs(t, result, 1, stringterm);
                    insert(t);
                }
            }
            else if (t.terms[1].ground && t.terms[2].ground) {
                if (args[2].endsWith(args[1])) {
                    try {
                        result = args[2].substring(0, args[2].length() - args[1].length());
                    } catch (StringIndexOutOfBoundsException e) {}
                    subs(t, result, 0, stringterm);
                    insert(t);
                }
            }
            else if (t.terms[2].ground) {
                len = args[2].length();
                subs(t, "", 0, stringterm);
                subs(t, args[2], 1, stringterm);
                insert(t);
                subs(t, "", 1, stringterm);
                subs(t, args[2], 0, stringterm);
                insert(t);
                for (i = 1; i < len; i++) {
                    result1 = args[2].substring(i);
                    try {
                        result = args[2].substring(0, i);
                    } catch (StringIndexOutOfBoundsException e) {
                    }
                    subs(t, result, 0, stringterm);
                    subs(t, result1, 1, stringterm);
                    insert(t);
                }
            }
        }
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     *@return    Description of the Return Value
     */
    public boolean evaluable(Atom t) {
        int i;
        int anzbound = 0;
        boolean ok = true;
//System.out.println("-> Concat evaluable");

        for (i = 0; i < 3; i++) {
            if (t.terms[i].ground) {
                anzbound++;
                if (!(t.terms[i] instanceof StringTerm) &&
                        !(t.terms[i] instanceof ConstTerm &&
                        (((ConstTerm) t.terms[i]).symbol >= SimpleEvaluatorConfig.STRINGSTART
                        )
                        )
                        ) {
                    return false;
                }
            }
        }
        if ((anzbound < 2) && !t.terms[2].ground) {
            return false;
        }
        return true;
    }


    /**
     *  Description of the Method
     *
     *@param  t           Description of the Parameter
     *@param  s           Description of the Parameter
     *@param  index       Description of the Parameter
     *@param  stringterm  Description of the Parameter
     */
    private void subs(Atom t, String s, int index, boolean stringterm) {
        if (stringterm) {
            t.terms[index] = new StringTerm(s, 0, true);
        }
        else {
            t.terms[index] = new ConstTerm(eval.setString(s));

        }
    }
}
