package org.semanticweb.triple.inference.builtins;

/*
 *  Name: rule.java
 *  Version: 1.0
 *  Purpose: numbers and string representations of rules
 *  History:
 */
import java.io.*;
import java.lang.Math;
import org.semanticweb.triple.inference.Atom;
import org.semanticweb.triple.inference.Variable;
import org.semanticweb.triple.inference.Term;
import org.semanticweb.triple.inference.StringTerm;
import org.semanticweb.triple.inference.BuiltinFunc;
import org.semanticweb.triple.inference.NumTerm;
import org.semanticweb.triple.inference.Rule;
import org.semanticweb.triple.inference.RuleSet;
import org.semanticweb.triple.inference.SimpleEvaluator;
import org.semanticweb.triple.inference.SimpleEvaluatorConfig;
import org.semanticweb.triple.inference.ConstTerm;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class rule extends BuiltinFunc {

    /**
     *  Constructor for the rule object
     */
    public rule() {
        super();
    }


    /**
     *  Constructor for the rule object
     *
     *@param  eval  Description of the Parameter
     */
    public rule(SimpleEvaluator eval) {
        super(eval);
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     */
    public void eval(Atom t) {
        Rule r;
        RuleSet rs = eval.getRuleset();
        String s = "";
        String touch = "";
        int z = -1;
        boolean ok;
        int anz;

        if (isString(t.terms[1])) {
            s = getString(t.terms[1]);
        }
        if (t.terms[0] instanceof NumTerm) {
            z = (int) ((NumTerm) t.terms[0]).zahl;
        }
        if (isString(t.terms[2])) {
            touch = getString(t.terms[2]);
        }

        if (z != -1) {
            for (r = rs.rules; r != null; r = r.next1) {
                if (!r.builtin && (z == r.no)) {
                    anz = getanz(r);
                    ok = false;
                    if (s == "") {
                        t.terms[1] = new ConstTerm(eval.setString(r.toString()));
                        ok = true;
                    }
                    else if (s.equals(r.toString())) {
                        ok = true;
                    }
                    if (touch == "") {
                        if (anz > 0) {
                            t.terms[2] = new ConstTerm(eval.setString("yes"));
                        }
                        else {
                            t.terms[2] = new ConstTerm(eval.setString("no"));
                        }
                    }
                    else {
                        if (touch.equals("yes") && (anz == 0)) {
                            ok = false;
                        }
                        if (touch.equals("no") && (anz > 0)) {
                            ok = false;
                        }
                    }
                    if (ok) {
                        insert(t);
                    }
                    break;
                }
            }
        }
        else if (s != "") {
            for (r = rs.rules; r != null; r = r.next1) {
                if (!r.builtin && (r.toString()).equals(s)) {
                    ok = false;
                    anz = getanz(r);
                    if (z == -1) {
                        t.terms[0] = new NumTerm(r.no);
                        ok = true;
                    }
                    else if (z == r.no) {
                        ok = true;
                    }
                    if (touch == "") {
                        if (anz > 0) {
                            t.terms[2] = new ConstTerm(eval.setString("yes"));
                        }
                        else {
                            t.terms[2] = new ConstTerm(eval.setString("no"));
                        }
                    }
                    else {
                        if (touch.equals("yes") && (anz == 0)) {
                            ok = false;
                        }
                        if (touch.equals("no") && (anz > 0)) {
                            ok = false;
                        }
                    }
                    if (ok) {
                        insert(t);
                    }
                    break;
                }
            }
        }
        else {
            for (r = rs.rules; r != null; r = r.next1) {
                if (!r.builtin) {
                    anz = getanz(r);
//System.out.println(anz);

                    t.terms[0] = new NumTerm(r.no);
                    t.terms[1] = new ConstTerm(eval.setString(r.toString()));
                    ok = true;
                    if (touch == "") {
                        if (anz > 0) {
                            t.terms[2] = new ConstTerm(eval.setString("yes"));
                        }
                        else {
                            t.terms[2] = new ConstTerm(eval.setString("no"));
                        }
                    }
                    else {
                        if (touch.equals("yes") && (anz == 0)) {
                            ok = false;
                        }
                        if (touch.equals("no") && (anz > 0)) {
                            ok = false;
                        }
                    }
                    if (ok) {
                        insert(t);
                    }
                }
            }

        }
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     *@return    Description of the Return Value
     */
    public boolean evaluable(Atom t) {
        if (!((t.terms[0] instanceof Variable) || (t.terms[0] instanceof NumTerm))) {
            return false;
        }
        if (!((t.terms[1] instanceof Variable) || (isString(t.terms[1])))) {
            return false;
        }
        if (!((t.terms[2] instanceof Variable) || (isString(t.terms[2])))) {
            return false;
        }
        return true;
    }


    /**
     *  Description of the Method
     *
     *@param  r  Description of the Parameter
     *@return    Description of the Return Value
     */
    int getanz(Rule r) {
        if (r.facts) {
            return r.heads[0].up.anztuples;
        }
        else {
            return r.hrelation.anztuples;
        }
    }


    /**
     *  Gets the string attribute of the rule object
     *
     *@param  t  Description of the Parameter
     *@return    The string value
     */
    private String getString(Term t) {
        if (t instanceof StringTerm) {
            return ((StringTerm) t).s;
        }
        else {
            return eval.getString(((ConstTerm) t).symbol);
        }

    }


    /**
     *  Gets the string attribute of the rule object
     *
     *@param  t  Description of the Parameter
     *@return    The string value
     */
    private boolean isString(Term t) {
        if ((t instanceof StringTerm) ||
                ((t instanceof ConstTerm && ((ConstTerm) t).symbol >= SimpleEvaluatorConfig.STRINGSTART))) {
            return true;
        }
        return false;
    }
}
