package org.semanticweb.triple.inference.builtins;
import org.semanticweb.triple.inference.Atom;
import org.semanticweb.triple.inference.Variable;
import org.semanticweb.triple.inference.Term;
import org.semanticweb.triple.inference.StringTerm;
import org.semanticweb.triple.inference.BuiltinFunc;
import org.semanticweb.triple.inference.NumTerm;
import org.semanticweb.triple.inference.SimpleEvaluator;
import org.semanticweb.triple.inference.SimpleEvaluatorConfig;
import org.semanticweb.triple.inference.ConstTerm;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class string2double extends BuiltinFunc {
    /**
     *  Constructor for the string2double object
     */
    public string2double() {
        super();
    }


    /**
     *  Constructor for the string2double object
     *
     *@param  eval  Description of the Parameter
     */
    public string2double(SimpleEvaluator eval) {
        super(eval);
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     */
    public void eval(Atom t) {
        Term args1 = t.terms[0];
        Term args2 = t.terms[1];
        String s = null;
        double d = 0;
        if (args1.ground) {
            if (args1 instanceof ConstTerm) {
                if (((ConstTerm) args1).symbol >= SimpleEvaluatorConfig.STRINGSTART) {
                    s = eval.getString(((ConstTerm) args1).symbol);
                }
            }
            else
                    if (args1 instanceof StringTerm) {
                s = ((StringTerm) args1).s;
            }

            if (args2 instanceof NumTerm) {
                d = ((NumTerm) args2).zahl;
                if ((Math.abs(Double.valueOf(s).doubleValue() - d)) < 0.00001) {
                    insert(t);
                }
                return;
            }
            else {
                d = Double.valueOf(s).doubleValue();
                ((Variable) args2).subsby = new NumTerm(d);
                insert(t);
                return;
            }

        }
        else {
            d = ((NumTerm) args2).zahl;
        }
        ((Variable) args1).subsby = new StringTerm(String.valueOf(d), 0, true);
        insert(t);
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     *@return    Description of the Return Value
     */
    public boolean evaluable(Atom t) {
        Term args1 = t.terms[0];
        Term args2 = t.terms[1];
        if (args1.ground) {
            if (args1 instanceof ConstTerm) {
                if (((ConstTerm) args1).symbol < SimpleEvaluatorConfig.STRINGSTART) {
                    return false;
                }
            }
            else
                    if (!(args1 instanceof StringTerm)) {
                return false;
            }

            if (!((args2 instanceof NumTerm) || args2 instanceof Variable)) {
                return false;
            }
        }
        else
                if (!(args2 instanceof NumTerm) || !(args1 instanceof Variable)) {
            return false;
        }
        return true;
    }
}
