package org.semanticweb.triple.language;

import java.util.*;
import org.semanticweb.glp.*;


abstract public class Formula extends TripleExpression {

  Term model; // every formula can have a model, even "and", "exists" etc. !

  public void putModel(Term model) { this.model = model; }

  public Term getModel() { return model; }

  public abstract GLogicFormula toGLP(GLPTerm model);
  
  // auxiliaries:
  
  GLPTerm overrideModel(GLPTerm model, Term newModel, ArrayList glpFormulae) {
    // must be used in toGLP in every concrete formula class!
    if (newModel != null)
      return newModel.toGLP(model, glpFormulae);
    else
      return model;
  }
  
  // model as prefix or suffix
  
  public void appendModel(Syntax syntax, StringBuffer buffer) {
    appendModel(syntax, buffer, false); // suffix
  }

  public void appendModel(Syntax syntax, StringBuffer buffer, boolean prefix) {
    if (model != null) {
      buffer.append("@");
      buffer.append(model.toString(syntax));
      if (prefix) buffer.append(" ");
    }
  }

}
