/*
 * Molecule.java
 *
 * Created on January 31, 2002, 11:37 AM
 */

package org.semanticweb.triple.language;

import java.util.*;
import org.semanticweb.glp.*;


/**
 * Note: cannot be used in TRIPLE0, i.e., in RDF version!
 * @author  Michael Sintek
 * @version 
 */
public class Molecule extends Atom {

  Term subject;
  ArrayList predicates = new ArrayList(); // of Term
  ArrayList objects = new ArrayList(); // of Term

  public void putSubject(Term subject) { this.subject = subject; }
  
  public void putPredicateAndObject(Term predicate, Term object) {
    // this prevents Molecule form being used in TRIPLE0!!
    // use Triple there instead!
    predicates.add(predicate);
    objects.add(object);
  }
  
  public String toString (Syntax syntax) {
    StringBuffer buffer = new StringBuffer();
    buffer.append(subject.toString(syntax));
    buffer.append("[");
    Iterator predIter = predicates.iterator();
    Iterator objIter = objects.iterator();
    while (predIter.hasNext()) {
      Term predicate = (Term)predIter.next();
      Term object = (Term)objIter.next();
      buffer.append(predicate.toString(syntax));
      buffer.append("->");
      buffer.append(object.toString(syntax));
      if (predIter.hasNext())
        buffer.append("; ");
    }
    buffer.append("]");
    appendModel(syntax, buffer);
    return buffer.toString();
  }
  
  public GLogicFormula toGLP(GLPTerm model) {
    // conjunction of true(triple(s',p',o'), model) + add. conjuncts
    // update model .... !!!
    ArrayList conjuncts = new ArrayList();
    ArrayList additionalConjuncts = new ArrayList();
    model = overrideModel(model, this.model, additionalConjuncts);
    GLPTerm glpSubject = subject.toGLP(model, additionalConjuncts);
    Iterator predIter = predicates.iterator();
    Iterator objIter = objects.iterator();
    while (predIter.hasNext()) {
      Term pred = (Term)predIter.next();
      Term obj = (Term)objIter.next();
      GLPTerm glpPred = pred.toGLP(model, additionalConjuncts);
      GLPTerm glpObj = obj.toGLP(model, additionalConjuncts);
      ArrayList spo = new ArrayList(3);
      spo.add(glpSubject);
      spo.add(glpPred);
      spo.add(glpObj);
      GLPTermFunction glpTriple = new GLPTermFunction("triple", spo);
      ArrayList trueargs = new ArrayList(2);
      trueargs.add(glpTriple);
      trueargs.add(model);
      GLPAtom trueAtom = new GLPAtom("true", trueargs);
      conjuncts.add(trueAtom);
    }
    return And.makeGLPConjunction(additionalConjuncts,
      And.makeGLPConjunction(conjuncts));
  }
  
    
}
