/*
 * QuantifierFormula.java
 *
 * Created on January 29, 2002, 1:04 PM
 */

package org.semanticweb.triple.language;

import java.util.*;


/**
 *
 * @author  Michael Sintek
 * @version 
 */
public abstract class QuantifierFormula extends Formula {

  ArrayList variables = new ArrayList(); // of Term
  Formula formula;
  
  public void putFormula(Formula formula) { this.formula = formula; }
  public void putVariables(Term variable) { variables.add(variable); }
    
  public Formula getFormula() { return formula; }
  public ArrayList getVariables() { return variables; }

  public String toString(String quantifier, Syntax syntax) {
    StringBuffer buffer = new StringBuffer();
    buffer.append(quantifier);
    buffer.append(" ");
    appendList(variables, buffer, syntax, ",");
    buffer.append(" (");
    buffer.append(formula.toString(syntax));
    buffer.append(")");
    appendModel(syntax, buffer);
    return buffer.toString();
  }
  
}
