package org.semanticweb.triple.parser;

import java.util.*;
import org.semanticweb.utilities.*;


public class LSymbol extends LTerm {

  String symbol;

  public LSymbol() { }

  public LSymbol(String symbol) {
    this.symbol = symbol;
  }

  public void putSymbol(String symbol) {
    this.symbol = symbol;
  }

  public String getSymbol() {
    return symbol;
  }

  public String toString() {
    return SyntaxHelper.symbol(symbol, false); // false = not PROLOG
  }
  
  public boolean equals(Object obj) { // only works for symbol != null
    if (obj != null && (obj instanceof LSymbol))
      return symbol.equals(((LSymbol)obj).symbol);
    else
      return false;
  }
  
  public LTerm normalize(HashMap abbreviations) {
    LTerm expansion = (LTerm)abbreviations.get(symbol);
    if (expansion != null)
      return expansion;
    else
      return this;
  }

}
