package org.semanticweb.triple.parser;

import java.util.*;
import org.semanticweb.utilities.*;


public class LVariable extends LTerm {

  String name;

  public LVariable() { }

  public LVariable(String name) {
    this.name = name;
  }

  public void putVariable(String name) {
    this.name = name;
  }

  public String getVariable() {
    return name;
  }

  public boolean isAnonymous() {
    return name == null;
  }
  
  public String toString() {
    if (name == null)
      return "_"; // or "?" ??
    else
      return "?" + SyntaxHelper.symbol(name, false); // quotes etc.
  }
  
  public boolean equals(Object obj) {
    if (obj instanceof LVariable) {
      String name2 = ((LVariable)obj).name;
      if (name != null)
        return name.equals(name2);
      else // name == null
        return name2 == null;
    } else
      return false;
  }

}
